package org.apache.maven.plugins.scm;

/* ====================================================================
 *   Copyright 2001-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 * ====================================================================
 */

import java.io.File;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.scm.ScmFile;
import org.apache.maven.scm.ScmFileSet;
import org.apache.maven.scm.command.status.StatusScmResult;
import org.apache.maven.scm.manager.ScmManager;
import org.apache.maven.scm.repository.ScmRepository;

/**
 * A bean for using the Maven SCM API because wrangling objects in Jelly is no fun.
 *
 * @author <a href="mailto:brett@apache.org">Brett Porter</a>
 */
public class ScmStatusBean
    extends ScmBean
{
    private List changedFiles;

    public void status()
        throws Exception
    {
        ScmManager scmManager = lookupScmManager();

        ScmRepository repository = getScmRepository( scmManager );

        StatusScmResult result = scmManager.getProviderByRepository( repository )
            .status( repository, new ScmFileSet( new File( getWorkingDirectory() ) ) );

        checkResult( result );

        changedFiles = result.getChangedFiles();

        for ( Iterator i = changedFiles.iterator(); i.hasNext(); )
        {
            ScmFile f = (ScmFile) i.next();
            if ( f.getPath().equals( "project.xml" ) || f.getPath().equals( "project.xml.backup" )
                || f.getPath().equals( "xdocs/changes.xml" ) || f.getPath().equals( "xdocs/changes.xml.backup" ) )
            {
                i.remove();
            }
        }
    }

    public List getChangedFiles()
    {
        return changedFiles;
    }
}
